<?php
namespace Faturamento\Repositories;

class Servprest extends \Doctrine\ORM\EntityRepository
{

    /**
     * @param $nrorg
     * @param $cdfilial
     * @param $cdprojeto
     * @param $nrbaseline
     * @param $cdversao
     * @return mixed
     */
    public static function consultaProxNrServPrest($nrorg, $cdempresa, $cdfunc, $cdcliente, $dtservprest){
        $sql = "
            SELECT TRIM(TO_CHAR(NVL(MAX(TO_NUMBER(SP.NRSERVPREST)), 0)+1, '00000')) AS NRSERVPREST
              FROM SERVPREST SP
             WHERE SP.NRORG = :NRORG
               AND SP.CDEMPRESA = :CDEMPRESA
               AND SP.CDFUNC = :CDFUNC
               AND SP.CDCLIENTE = :CDCLIENTE
               AND SP.DTSERVPREST = TO_DATE(:DTSERVPREST, 'DD/MM/YYYY HH24:MI:SS')
        ";
        
        $params = array(
            'NRORG'       => $nrorg, 
            'CDEMPRESA'   => $cdempresa, 
            'CDFUNC'      => $cdfunc, 
            'CDCLIENTE'   => $cdcliente, 
            'DTSERVPREST' => $dtservprest         
        );

        try{
            return \Setforms2\Shared\Connection::getInstance()->fetchAll($sql, $params);
        } catch(\Exception $e) {
            throw $e;
        }
    }

}