/* Sistemas Integrados TEKNISA

Nome: 5014_FISFUNS_CTBL_PRODPRODUCAO.SQL

Descrio:
Funo para retornar a conta contabil dos produtos em processo.

P_CDPRODUTO       - Cdigo do produto.

Converso:
07/08/2008 - Leonardo Bispo de Souza
*/


IF EXISTS (SELECT * FROM SYSOBJECTS O, SYSUSERS U
           WHERE O.NAME = 'CTBL_PRODPRODUCAO'  AND
                 TYPE = 'FN' 		       AND
	              U.UID = O.UID            AND
	              U.NAME = USER)
DROP FUNCTION CTBL_PRODPRODUCAO
GO

CREATE FUNCTION CTBL_PRODPRODUCAO(
   @P_CDPRODUTO  VARCHAR(10)) RETURNS VARCHAR(20)
AS
BEGIN
   DECLARE @V_CDCTBLPRODPR   VARCHAR(20);
   DECLARE @V_CDARVPROD   VARCHAR(20);

   SET @V_CDCTBLPRODPR = NULL;
   SET @V_CDARVPROD = NULL;

   SELECT @V_CDARVPROD = CDARVPROD 
   FROM PRODUTO
   WHERE CDPRODUTO = @P_CDPRODUTO;

      SELECT @V_CDCTBLPRODPR = PR.CDCTBLPRODPR 
        FROM PRODUTO PR,
             (SELECT MAX(CDARVPROD) AS CDARVPROD
                FROM PRODUTO C
               WHERE (CHARINDEX(@V_CDARVPROD,RTRIM(C.CDARVPROD)) = 1)
                 AND NOT CDCTBLPRODPR IS NULL) P
       WHERE PR.CDARVPROD = P.CDARVPROD;

   RETURN(@V_CDCTBLPRODPR);
END
GO


-- VERSAO --
EXEC ATUVEROBJ 'CTBL_PRODPRODUCAO','5.05.025';
GO
